$(document).on('click', '.productcovervideo', function (e) {
    $(this).hide(500);
});
$('.productcovervideo').show();

$("#favicon").attr("href", $('div#brander').attr('data-websitefavicon'));
//$("div.popup").addClass("modal fade");
//$("a.popup").attr("data-toggle", "modal");
$(".body-editor").css("height", "100%");

$('.blurlaptopscomps').addClass('hidelaptopscomps').removeClass('blurlaptopscomps');
$('.blursmalllaptops').addClass('hidesmalllaptops').removeClass('blursmalllaptops');
$('.blurtablets').addClass('hidetablets').removeClass('blurtablets');
$('.blurphones').addClass('hidephones').removeClass('blurphones');
$('.blurall').addClass('hideall').removeClass('blurall');

$('a').each(function() {
    var $currentA = $(this);
    var dataHref = $currentA.attr('data-href');
    $currentA.attr('href', dataHref);
});

//Lazy Load Background Images Start
function BackgroundNode({node, loadedClassName}) {
	let src = node.getAttribute('data-background');
	let show = (onComplete) => {
		requestAnimationFrame(() => {
			node.style.backgroundImage = `url(${src})`
			node.classList.add(loadedClassName);
			onComplete();
		})
	}
	return {
		node,
		// onComplete is called after the image is done loading.
		load: (onComplete) => {
			let img = new Image();
			img.onload = show(onComplete);
			img.src = src;
		}
	}
}

let defaultOptions = {
	selector: '[data-background]',
	loadedClassName: 'loaded'
}

function BackgroundLazyLoader({selector, loadedClassName} = defaultOptions) {
	let nodes = [].slice.apply(document.querySelectorAll(selector))
		.map(node => new BackgroundNode({node, loadedClassName}));
	let callback = (entries, observer) => {
		entries.forEach(({target, isIntersecting}) => {
			if (!isIntersecting) {
				return;
			}
			let obj = nodes.find(it => it.node.isSameNode(target));
			if (obj) {
				obj.load(() => {
					// Unobserve the node:
					observer.unobserve(target);
					// Remove this node from our list:
					nodes = nodes.filter(n => !n.node.isSameNode(target));
					
					// If there are no remaining unloaded nodes,
					// disconnect the observer since we don't need it anymore.
					if (!nodes.length) {
						observer.disconnect();
					}
				});
			}
		})
	};
	let observer = new IntersectionObserver(callback);
	nodes.forEach(node => observer.observe(node.node));
};
BackgroundLazyLoader();
//Lazy Load Background Images End

//AOS Functions
AOS.init({
    // Global settings:
    disable: false, // accepts following values: 'phone', 'tablet', 'mobile', boolean, expression or function
    startEvent: 'load', // name of the event dispatched on the document, that AOS should initialize on
    initClassName: 'aos-init', // class applied after initialization
    animatedClassName: 'aos-animate', // class applied on animation
    useClassNames: false, // if true, will add content of `data-aos` as classes on scroll
    disableMutationObserver: false, // disables automatic mutations' detections (advanced)
    debounceDelay: 50, // the delay on debounce used while resizing window (advanced)
    throttleDelay: 99, // the delay on throttle used while scrolling the page (advanced)

    // Settings that can be overridden on per-element basis, by `data-aos-*` attributes:
    offset: 0, // offset (in px) from the original trigger point
    delay: 0, // values from 0 to 3000, with step 50ms
    duration: 1500, // values from 0 to 3000, with step 50ms
    easing: 'ease', // default easing for AOS animations
    once: false, // whether animation should happen only once - while scrolling down
    mirror: false, // whether elements should animate out while scrolling past them
    anchorPlacement: 'top-bottom', // defines which position of the element regarding to window should trigger the animation
});

// Hide Show Header On Mobile
$(function(){ // DOM READY shorthand
    $(".slidingDiv").show();
    $('.show_hide').click(function( e ){
        var SH = this.SH^=1; // "Simple toggler"
        $(this).text(SH?'Show':'Hide')
               .next(".slidingDiv").slideToggle();
    });
}); 

// Date Timer - Start
(function(){
    var $day = $('.datetimer').data('day')
    var $month = $('.datetimer').data('month')
    var $year = $('.datetimer').data('year')
    var $hour = $('.datetimer').data('hour')
    var $minute = $('.datetimer').data('minute')
    var $timezone = $('.datetimer').data('timezone')
    var $url = $('.datetimer').data('dturl');
    date = `${$month} ${$day}, ${$year} ${$hour}:${$minute} ${$timezone}`;  
    console.log(date);
    var deadline = date;
    initializeClock('clockdiv', deadline);
    let redirectInterval = setInterval(() => {
        let t = getTimeRemaining(deadline);
        if (t.total <= 0) {
            clearInterval(redirectInterval);
            if($url && $url !== ''){
                window.location = $url;
            }
        }
    }, 1000);
})();
// Date Timer - End

// Custom Timer - Start
var days = $('.customtimer').data('days'),
    hours = $('.customtimer').data('hours'), 
    minutes = $('.customtimer').data('minutes'), 
    seconds = $('.customtimer').data('seconds');
var is_cyclic = false;
var ptDuration = $("#clockdiv").data('pt-duration');
ptDuration = parseInt(ptDuration);

 if(localStorage.getItem('reset') == 1){
    var reset = 1;
    localStorage.setItem('reset', 0);
 }
 else{
    var reset = 0;
 }

var resetTimer;
var dayDivider = 1000 * 60 * 60 * 24;
var hourDivider = 1000 * 60 * 60;
var minuteDivider = 1000 * 60;
function runTimer(){
  var si = setInterval(function(){
    var timer = getItems('end_time') - Date.now();
    //console.log(timer);
    if(timer >= 0){
      var dayTD = Math.floor(timer / dayDivider);
      var hourTD = Math.floor((timer % dayDivider) / hourDivider);
      var minuteTD = Math.floor((timer % hourDivider) / minuteDivider);
      var secondTD = Math.floor((timer % minuteDivider) / 1000);
      setEl('days', dayTD, '');
      setEl('hours', hourTD, '');
      setEl('minutes', minuteTD, ''); 
      setEl('seconds', secondTD, '');
    }
    else{
        clearInterval(si);
        // startOver();
    }
  },0);
}
function startOver(){
    days = $('.customtimer').data('days');
    hours = $('.customtimer').data('hours');
    minutes = $('.customtimer').data('minutes');
    seconds = $('.customtimer').data('seconds');
    localStorage.setItem('start_time', Date.now());
    calcTime();
    localStorage.setItem('end_time', Date.now() + resetTimer);
    localStorage.setItem('run', 1);
    runTimer();
}
function calcTime(){
    resetTimer = parseInt(days) * 24 * 60 * 60 + parseInt(hours) * 60 * 60 + parseInt(minutes) * 60 + seconds;
    resetTimer *= 1000;
}
function getItems(item){
    if(localStorage.getItem(item)) return parseInt(localStorage.getItem(item));
    return 0;
}
function setEl(elid, value, sf){
    // document.getElementById(elid).innerHTML = value + sf;
    $('.' + elid).html(value + sf);
    // console.log(elid, value, sf);
}

$(document).ready(function(){
    // console.log("Page loaded");
    const path = window.location.pathname;
    const keyReset = path + "-reset";
    const keyRun = path + "-run";
    const keyStop = path + "-stop";
    const keyStartTime = path + "-start-time";
    const keyEndTime = path + "-end-time";
    const keyDuration = path + "-duration";
    const keyUrl = path + "-cturl";
    
    function calculateRemainingTime(){
        resetTimer = parseInt(days) * 24 * 60 * 60 + parseInt(hours) * 60 * 60 + parseInt(minutes) * 60 + seconds;
        resetTimer *= 1000;
        return resetTimer;
    }
    
    function isDisabled() {
        const dataEnabled = $('.customtimer').data('enabled');
        const isEnabled = dataEnabled == null || (dataEnabled && dataEnabled == "1");
        
        if(!isEnabled) {
            return true;
        }
        
        return false;
    }
    
    function removeKeysFromStorage() {
        localStorage.removeItem(keyRun);
        localStorage.removeItem(keyEndTime);
    }
    
    function runcustomTimer(){
      var si = setInterval(function(){
        if(isDisabled()) {
            clearInterval(si);
        }
        var timer = getItems(keyEndTime) - Date.now();
        //console.log(timer);
        if(timer >= 0){
          var dayTD = Math.floor(timer / dayDivider);
          var hourTD = Math.floor((timer % dayDivider) / hourDivider);
          var minuteTD = Math.floor((timer % hourDivider) / minuteDivider);
          var secondTD = Math.floor((timer % minuteDivider) / 1000);
          if (is_cyclic) {
              
          }
          setEl('days', dayTD, '');
          setEl('hours', hourTD, '');
          setEl('minutes', minuteTD, ''); 
          setEl('seconds', secondTD, '');
        }
        else{
            
            if (is_cyclic) {
                // restart
                initializecustomTimer();
            } else {
                clearInterval(si);
                // redirect now
                var redirectUrl = $('.customtimer').data('cturl');
                if(redirectUrl && redirectUrl !== ''){
                    if(redirectUrl.indexOf("http") == -1) {
                        redirectUrl = "http://" + redirectUrl;
                    }
                    window.location.href = redirectUrl;
                }
            }
        }
      }, 0);
    }
        
    function initializecustomTimer() {
        if(isDisabled()) {
            return;
        }
        
        days = $('.customtimer').data('days');
        hours = $('.customtimer').data('hours');
        minutes = $('.customtimer').data('minutes');
        seconds = $('.customtimer').data('seconds');
        is_cyclic = $('.pagetimer').data('cyclic');

        localStorage.setItem(keyStartTime, Date.now());
        
        calculateRemainingTime();
        
        localStorage.setItem(keyEndTime, Date.now() + resetTimer);
        localStorage.setItem(keyRun, 1);
        localStorage.setItem(keyDuration, resetTimer);
        localStorage.setItem(keyUrl, $('.customtimer').data('cturl'));
        
        runcustomTimer();
    }
    
    function checkIfTimerValueIsChanged() {
        days = $('.customtimer').data('days');
        hours = $('.customtimer').data('hours');
        minutes = $('.customtimer').data('minutes');
        seconds = $('.customtimer').data('seconds');
        
        const oldDuration = getItems(keyDuration);
        const currentDuration = calculateRemainingTime();
        
        console.log(oldDuration, currentDuration);
        if(oldDuration != currentDuration) {
            return true;
        }
        
        const oldUrl = localStorage.getItem(keyUrl);
        const currentUrl = $('.customtimer').data('cturl');
        
        console.log(oldUrl, currentUrl);
        if(oldUrl != currentUrl) {
            return true;
        }
        
        return false;
    }
    
    var ptStart = $("#clockdiv").data('pt-start');
    ptStart = parseInt(ptStart);

    function runPageTimer() {
        // console.log(ptStart);
        if (ptStart <= 0) return;
        
        var currTime = new Date().getTime();
        // while (ptStart + ptDuration < currTime) {
        //     console.log('Expired?', ptStart, ptDuration, ptStart + ptDuration, currTime);
        //     // expired; enable cyclic timer?
        //     // return;
        //     ptStart += ptDuration;
        // }
        if (is_cyclic) {
            var time_diff = currTime - ptStart;
            console.log("time diff", time_diff);
            if (time_diff >= ptDuration) {
                var factor = Math.floor(time_diff / ptDuration);
                ptStart += (factor * ptDuration);
                
            }
        }
        console.log("Running start time", ptStart);
        var ptInterval = setInterval(function(){
            var currTimeNow = new Date().getTime();
            var timer = (ptStart + ptDuration) - currTimeNow;
            // console.log(timer, ptStart, currTimeNow);
            if (timer >= 0) {
                var dayTD = Math.floor(timer / dayDivider);
                var hourTD = Math.floor((timer % dayDivider) / hourDivider);
                var minuteTD = Math.floor((timer % hourDivider) / minuteDivider);
                var secondTD = Math.floor((timer % minuteDivider) / 1000);
                setEl('days', dayTD, '');
                setEl('hours', hourTD, '');
                setEl('minutes', minuteTD, ''); 
                setEl('seconds', secondTD, '');
            } else {
                if (is_cyclic) {
                    // restart
                    ptStart = ptStart + ptDuration;
                    runPageTimer();
                } else {
                    clearInterval(ptInterval);
                    // redirect?
                    var redirectUrl = $('.pagetimer').data('pturl');
                    if(redirectUrl && redirectUrl !== ''){
                        if(redirectUrl.indexOf("http") == -1) {
                            redirectUrl = "http://" + redirectUrl;
                        }
                        window.location.href = redirectUrl;
                    }                    
                    
                    
                }
            }
        }, 0);
    }
    
    if (ptDuration > 0) {
        // page timer
        is_cyclic = $('#clockdiv').data('cyclic');
        console.log("Starting page timer:", ptDuration, is_cyclic);
        runPageTimer();
    } else {
        const stopData = localStorage.getItem(keyStop);
        const isStopped = stopData && stopData == "1";
        
        const runData = localStorage.getItem(keyRun);
        const isRunning = runData && runData == "1";
        
        const resetData = localStorage.getItem(keyReset);
        const isReset = resetData && resetData == "1";
        
        if(!isStopped && !isRunning) {
            // first time loaded
            initializecustomTimer();
        }
        else if(!isStopped && isRunning) {
            // check if the page is reloaded and endtime is different
            const isTimerValueUpdated = checkIfTimerValueIsChanged();
            if(isTimerValueUpdated) {
                initializecustomTimer();
            }
            else {
                // continue the timer
                runcustomTimer();
            }
        }
        else if(isStopped) {
            // do nothing
        }
    }
});
// Custom Timer - End